#ifndef READER_H
#define READER_H

#include "UnitTest.h"
#include "const_include.h"
#include <vector>
#include <string>
#include <cstring>
#include <iostream>
#include <fstream>
#include <cstdio>

using namespace std;

/* 
 * The ChromReader class is used to store the genome that is loaded in a decent size.
 */
class Reader {
	public:
		Reader();
		~Reader();
		
		/*
		 * Constructor.  Creates new ChromReader with filename.
		 * fn - the filename of the file to be parsed into the genome.
		 */
		Reader(const char* fn);
		
		void use(string str) {
			use(str.c_str());
		}
		void use(const char* fn);
		
		Reader& operator =(const Reader &other);
		bool read(unsigned char* genome);
		
		string GetName() const;
		long GetFileSize() const;
		
		static bool Test(ostream &os);

	private:
		void Init(const char* fn);

		char* filename;
		BIT64_t buffer_read;
		BIT64_t current_offset;
		bool finished_reading;
		string chr_name;
		long file_size;

};

#endif
