#ifndef HASH_MAP_H
#define HASH_MAP_H


template <typename KEY_TYPE, class MAP_TYPE>
class hash_map {
	public:
		hash_map<KEY_TYPE, MAP_TYPE>():
			num_elements(0), max_size(1000) {
			_hash_map = new MAP_TYPE[max_size];
		}
		
		hash_map<KEY_TYPE, MAP_TYPE>(unsigned long size) :
			num_elements(0), max_size(size) {
			_hash_map = new MAP_TYPE[size];
		}

		~hash_map<KEY_TYPE, MAP_TYPE>(){
			delete[] _hash_map;
		}
		
		MAP_TYPE& operator[](KEY_TYPE &hash_spot) {
			if(static_cast<unsigned long>(hash_spot) > max_size)
				resize(max_size * 10);
		
			return _hash_map[static_cast<unsigned long>(hash_spot)];
		}
		
		void set_size(unsigned long new_size) {
			resize(new_size);
		}
		
		unsigned long size() {
			return max_size;
		}

	private:
		void resize(unsigned long new_size) {
			MAP_TYPE* hash_temp = new MAP_TYPE[new_size];
			for(unsigned long i=0; i<max_size; i++)
				hash_temp[i] = _hash_map[i];
				
			delete[] _hash_map;
			_hash_map = hash_temp;
			max_size = new_size;
		}
	
		MAP_TYPE* _hash_map;
		unsigned long num_elements;
		unsigned long max_size;
};


#endif //HASH_MAP_H
